package com.itppay.react;

import android.app.Activity;
import android.util.Log;
import android.widget.Toast;

import com.facebook.react.bridge.Arguments;
import com.facebook.react.bridge.Callback;
import com.facebook.react.bridge.Promise;
import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.bridge.ReactContextBaseJavaModule;
import com.facebook.react.bridge.ReactMethod;
import com.facebook.react.bridge.ReadableMap;
import com.facebook.react.bridge.WritableMap;
import com.tech.dlpaysdk.activity.DLPayManagers;
import com.tech.dlpaysdk.callback.DLPayCallBack;


import org.json.JSONObject;

import java.util.HashMap;
import java.util.Map;

import javax.annotation.Nullable;

/**
 * Created by itppay 
 */

public class ITPPayModule extends ReactContextBaseJavaModule {

    private static final String ALIPAY = "ALIPAY";
    private static final String JD = "JD";
    private static final String WECHAT = "WECHAT";
    private static final String QQ = "QQ";
    private static final String UNIONPAY = "UNIONPAY";



    public ITPPayModule(ReactApplicationContext reactContext) {
        super(reactContext);
    }

    @Override
    public String getName() {
        return "ITPPayModule";
    }

    @Nullable
    @Override
    public Map<String, Object> getConstants() {
        final Map<String, Object> constants = new HashMap<>();
        constants.put(ALIPAY, DLPayCallBack.PAY_WITH_ZHIFUBAO);
        constants.put(JD, DLPayCallBack.PAY_WITH_JD);
        constants.put(QQ, DLPayCallBack.PAY_WITH_QQ);
        constants.put(UNIONPAY, DLPayCallBack.PAY_WITH_UNIONPAY);
        constants.put(WECHAT, DLPayCallBack.PAY_WITH_WEIXIN);
        return constants;
    }

    @ReactMethod
    public void dlPay(ReadableMap params, final Callback tpCallback){

        final Activity activity = getCurrentActivity();
        
		String appid = params.getString("appid");
		String appkey = params.getString("appkey");
		String subject = params.getString("subject");
		int    amount = Integer.parseInt(params.getString("amount"));
		String body = params.getString("body");
		String mchntOrderNo = params.getString("mchntOrderNo");
		String notifyUrl = params.getString("notifyUrl");
		String cpChannel = params.getString("cpChannel");
		String description = params.getString("description");
		String extra = params.getString("extra");
		String payStyle = params.getString("payStyle");
		final  DLPayManagers managers = DLPayManagers.getInstance(activity,appid);

		managers.startDLPaysdk(appkey, subject, amount, body, mchntOrderNo, notifyUrl, cpChannel, description, extra, payStyle, new DLPayCallBack() {
			@Override
			public void dlPayResult(String payResultCode, String msg) {
				tpCallback.invoke(payResultCode,msg);
			}
		});
        

    }

}
